<?php

/* Server Info Script: Version 1.0.0 */

require("armagetron_php_client.php");

$settings = array(
				  connection => array(
									  host => NULL,
									  port => 0,
									  static_name => NULL
									  ),
				  colors => array(
								  down  => array( code => "#FF0000",
												  name => "red" ),
								  up	=> array( code => "#00EE00",
												  name => "green" ),
								  server_colors => false
								  )
				  );

function displayInfo($settings)
{
	$info = new serverinfo( $settings[connection][host], $settings[connection][port] );

	if( is_null( $info ) )
	{
		die( "Error getting server info: Contents of $info: \"" . $info . "\"" );
	}

	if( is_null( $info->version ) ) // Pick something easy. If the version is NULL, the server must not be up.
	{
		echo( "<span style = 'color: " . $settings[colors][down][code] . "'>" . $settings[connection][static_name] . "</span><br /><br />\n" );
	}
	else
	{
		if( $settings[colors][server_colors] == false )
		{
			echo( "<span style = 'color: " . $settings[colors][up][code] . "'>" . filtercolors( $info->name ) . "</span><br />\nPlayers:" );
		} 
		else
		{
			echo( convertcolors( $info->name ) . "<br />\nPlayers:" );
		}
		if( $info->players[0] == NULL ) // If the first player is NULL, then there aren't any players there. NOTE: Don't use is_null here, it doesn't work.
		{
			echo( " None" );
		}
		else
		{
			echo( ' ' . implode( ', ', @$info->players ) );	
		}
		echo( "<br />\nVersion: " . $info->version . "<br />\n<br />\n" );
	}
}

function checkOrDie($host, $port, $static_name, $number)
{
	if( is_null( $host ) && ( !is_int( $port ) && $port == 0 ) && is_null( $staticName ) )
	{
		die( "No parameters specified for server " . $number . "." );
	}
	if( gethostbyname( $host ) == $host )
	{
		die( "Error resolving hostname." );
	}
	
	if( !is_int( $port ) || $port == 0 )
	{
		die( "Invalid port value or unspecified port." );
	}
	
	if( is_null( $static_name ) )
	{
		die( "Static name of server is unspecified." );
	}
	return true;
}

/* ----------------------------------------------------------------------------------------- */

$get_size = count( $_GET );
$index = 1;

if( $get_size < 1 )
{
	die( "No parameters specified.");
}

$settings[colors][server_colors] = (bool)$_GET["server_colors"];

for( $a = 0; $a < $get_size; $a += 3 )
{
	/*
	  Query Vars:
	  host1, host2, host3... - The server's IP or localhost
	  port1, port2, port3... - The server's port
	  name1, name2, name3... - The server's static name
	*/
	
	$settings[connection][host] = $_GET["host" . $index];
	$settings[connection][port] = (int)$_GET["port" . $index];
	$settings[connection][static_name] = $_GET["name" . $index];
	
	checkOrDie( $settings[connection][host], $settings[connection][port], $settings[connection][static_name], $index );
	displayInfo( $settings );
	$index++;
}

echo ( "<hr />\nServers that are down are shown in <span style = 'color: " . $settings[colors][down][code] . "'>" . $settings[colors][down][name] . "</span>. Servers that are up are shown in <span style = 'color: " . $settings[colors][up][code] . "'>" . $settings[colors][up][name] . "</span>." );
?>